> This page is for version v2 (default).
> For other versions, use one of these documentation indexes:
> - v2 (default): https://developers.clearpay.co.uk/v-2/llms.txt
> - v1: https://developers.clearpay.co.uk/v-1/llms.txt

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developers.clearpay.co.uk/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developers.clearpay.co.uk/_mcp/server.

# Create Refund

POST https://global-api-sandbox.afterpay.com/v2/payments/{orderId}/refund
Content-Type: application/json

This endpoint performs a full or partial refund.

The refund operation is [idempotent](/idempotent-requests) if a unique `requestId` and `merchantReference` are provided.

If using the [Deferred Payment Flow](/deferred-payment-flow), please be aware that only captured funds can be refunded.

## Successful Response (201)

Returns a [Refund object](/refund-object) in response. All request parameters will be echoed in the response. In addition, the response includes the following:

| Attribute    | Type   | Description                                                                                                                  |
| :----------- | :----- | :--------------------------------------------------------------------------------------------------------------------------- |
| `refundId`   | string | The unique, permanent, Clearpay-generated Refund ID.                                                                         |
| `refundedAt` | string | The UTC timestamp of when the refund was completed, in [ISO 8601](http://www.iso.org/iso/home/standards/iso8601.htm) format. |

## Connection Timeouts

| Timeout | Time (Seconds) |
| :------ | :------------- |
| Open    | 10             |
| Read    | 70             |

## Errors

In addition to the [PUT/POST Errors](/put-post-errors) applicable to all POST endpoints, the following errors are specific to Create Refund:

| HTTP Status Code              | errorCode             | Description                                                                                                     |
| :---------------------------- | :-------------------- | :-------------------------------------------------------------------------------------------------------------- |
| **412**  Precondition Failed  | `precondition_failed` | The `orderId` is invalid, does not exist, or is not eligible for a refund. For example, the order was declined. |
| **422**  Unprocessable Entity | `invalid_object`      | The `refundMerchantReference` exceeded 128 characters.                                                          |
| **422**  Unprocessable Entity | `invalid_amount`      | The `amount` requested exceeded the amount available.                                                           |
| **422**  Unprocessable Entity | `invalid_object`      | The currency of the refund does not match the currency of the order (and the Merchant account).                 |

Reference: https://developers.clearpay.co.uk/api-reference/create-refund

## Authentication

- `Authorization` header (basic auth, required) — Basic authentication of the form `Basic <base64(username:password)>`.

## Request

### Path parameters

- `orderId` (string, required) — The unique Clearpay Order ID to apply the refund to.

### Headers

- `Accept` (string, optional, default: application/json)

### Body (application/json)

This endpoint expects an object.

- `amount` (V2PaymentsOrderIdRefundPostRequestBodyContentApplicationJsonSchemaAmount, required) — The refund amount. The refund amount can not exceed the payment total.
- `requestId` (string, optional) — A unique request ID, required for safe retries. It is recommended that the merchant generate a UUID for each unique refund.
- `merchantReference` (string, optional) — The merchant’s internal refund id/reference. This must be included along with the `requestId` to utilise idempotency. Max length 85 (varchar)
- `refundMerchantReference` (string, optional) — A unique reference for the individual refund event. If provided, the value will appear in the daily settlement file as "Payment Event ID". Limited to 128 characters.

## Types

### V2PaymentsOrderIdRefundPostRequestBodyContentApplicationJsonSchemaAmount

The refund amount. The refund amount can not exceed the payment total.

- `amount` (string, required, default: 0.00) — The amount as a string representation of a decimal number, rounded to 2 decimal places.
- `currency` (string, required, default: GBP) — The currency in [ISO 4217](https://en.wikipedia.org/wiki/ISO_4217) format.

## Examples

**Request**

```json
{
  "amount": {
    "amount": "0.00",
    "currency": "GBP"
  }
}
```

**SDK Code**

```python
import requests

url = "https://global-api-sandbox.afterpay.com/v2/payments/orderId/refund"

payload = { "amount": {
        "amount": "0.00",
        "currency": "GBP"
    } }
headers = {
    "User-Agent": "User-Agent"
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers, auth=("<username>", "<password>"))

print(response.json())
```

```javascript
const url = 'https://global-api-sandbox.afterpay.com/v2/payments/orderId/refund';
const credentials = btoa("<username>:<password>");

const options = {
  method: 'POST',
  headers: {
    'User-Agent': 'User-Agent',
    Authorization: `Basic ${credentials}`,
    'Content-Type': 'application/json'
  },
  body: '{"amount":{"amount":"0.00","currency":"GBP"}}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://global-api-sandbox.afterpay.com/v2/payments/orderId/refund"

	payload := strings.NewReader("{\n  \"amount\": {\n    \"amount\": \"0.00\",\n    \"currency\": \"GBP\"\n  }\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("User-Agent", "User-Agent")
	req.SetBasicAuth("<username>", "<password>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://global-api-sandbox.afterpay.com/v2/payments/orderId/refund")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["User-Agent"] = 'User-Agent'
request.basic_auth("<username>", "<password>")
request["Content-Type"] = 'application/json'
request.body = "{\n  \"amount\": {\n    \"amount\": \"0.00\",\n    \"currency\": \"GBP\"\n  }\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://global-api-sandbox.afterpay.com/v2/payments/orderId/refund")
  .header("User-Agent", "User-Agent")
  .basicAuth("<username>", "<password>")
  .header("Content-Type", "application/json")
  .body("{\n  \"amount\": {\n    \"amount\": \"0.00\",\n    \"currency\": \"GBP\"\n  }\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://global-api-sandbox.afterpay.com/v2/payments/orderId/refund', [
  'body' => '{
  "amount": {
    "amount": "0.00",
    "currency": "GBP"
  }
}',
  'headers' => [
    'Content-Type' => 'application/json',
    'User-Agent' => 'User-Agent',
  ],
    'auth' => ['<username>', '<password>'],
]);

echo $response->getBody();
```

```csharp
using RestSharp;
using RestSharp.Authenticators;

var client = new RestClient("https://global-api-sandbox.afterpay.com/v2/payments/orderId/refund");
client.Authenticator = new HttpBasicAuthenticator("<username>", "<password>");
var request = new RestRequest(Method.POST);
request.AddHeader("User-Agent", "User-Agent");

request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"amount\": {\n    \"amount\": \"0.00\",\n    \"currency\": \"GBP\"\n  }\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let credentials = Data("<username>:<password>".utf8).base64EncodedString()

let headers = [
  "User-Agent": "User-Agent",
  "Authorization": "Basic \(credentials)",
  "Content-Type": "application/json"
]
let parameters = ["amount": [
    "amount": "0.00",
    "currency": "GBP"
  ]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://global-api-sandbox.afterpay.com/v2/payments/orderId/refund")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```